<template>
  <div>
    <!-- <img
      :src="options.img"
      title="点击上传头像"
      class="img-circle img-lg"
      @click="editCropper()"
    /> -->
    <el-upload
      class="img-circle img-lg"
      :action="ossUploadUrl"
      :show-file-list="false"
      :http-request="handleAvatarSuccess"
      :before-upload="beforeAvatarUpload"
      :data="dataObj"
    >
      <el-image
        v-if="options.img"
        :src="options.img"
        class="avatar"
        fit="cover"
      />
      <i v-else class="el-icon-plus avatar-uploader-icon"></i>
    </el-upload>
    <!-- <el-dialog :title="title" :visible.sync="open" width="800px">
      <el-row>
        <el-col :xs="24" :md="12" :style="{ height: '350px' }">
          <vue-cropper
            ref="cropper"
            :img="options.img"
            :info="true"
            :auto-crop="options.autoCrop"
            :auto-crop-width="options.autoCropWidth"
            :auto-crop-height="options.autoCropHeight"
            :fixed-box="options.fixedBox"
            @realTime="realTime"
          />
        </el-col>
        <el-col :xs="24" :md="12" :style="{ height: '350px' }">
          <div class="avatar-upload-preview">
            <img :src="previews.url" :style="previews.img" />
          </div>
        </el-col>
      </el-row>
      <br />
      <el-row>
        <el-col :lg="2" :md="2">
          <el-upload
            action="#"
            :http-request="requestUpload"
            :show-file-list="false"
            :before-upload="beforeUpload"
          >
            <el-button size="small">
              上传
              <i class="el-icon-upload el-icon--right" />
            </el-button>
          </el-upload>
        </el-col>
        <el-col :lg="{ span: 1, offset: 2 }" :md="2">
          <el-button icon="el-icon-plus" size="small" @click="changeScale(1)" />
        </el-col>
        <el-col :lg="{ span: 1, offset: 1 }" :md="2">
          <el-button
            icon="el-icon-minus"
            size="small"
            @click="changeScale(-1)"
          />
        </el-col>
        <el-col :lg="{ span: 1, offset: 1 }" :md="2">
          <el-button
            icon="el-icon-refresh-left"
            size="small"
            @click="rotateLeft()"
          />
        </el-col>
        <el-col :lg="{ span: 1, offset: 1 }" :md="2">
          <el-button
            icon="el-icon-refresh-right"
            size="small"
            @click="rotateRight()"
          />
        </el-col>
        <el-col :lg="{ span: 2, offset: 6 }" :md="2">
          <el-button type="primary" size="small" @click="uploadImg()"
            >提 交</el-button
          >
        </el-col>
      </el-row>
    </el-dialog> -->
  </div>
</template>

<script>
import store from "@/store";
import { VueCropper } from "vue-cropper";
import { uploadAvatar } from "@/api/system/sysuser";
import { policy } from "@/api/user";
import { getUploadSign, onOnlyFileUpload } from "@/helpers/oss-file-upload";
export default {
  components: { VueCropper },
  props: {
    // eslint-disable-next-line vue/require-default-prop
    user: { type: Object },
  },
  data() {
    return {
      // 是否显示弹出层
      open: false,
      // 弹出层标题
      title: "修改头像",
      options: {
        img: store.getters.avatar, // 裁剪图片的地址
        autoCrop: true, // 是否默认生成截图框
        autoCropWidth: 200, // 默认生成截图框宽度
        autoCropHeight: 200, // 默认生成截图框高度
        fixedBox: true, // 固定截图框大小 不允许改变
      },
      previews: {},
      info: null,
      // ossUploadUrl: "https://ks3-cn-beijing.ksyuncs.com/daya",
      ossUploadUrl: "https://daya.ks3-cn-beijing.ksyuncs.com",
      dataObj: {
        policy: "",
        signature: "",
        key: "",
        KSSAccessKeyId: "",
        acl: "public-read",
        name: "",
      },
    };
  },
  methods: {
    async beforeAvatarUpload(file) {
      const isLt2M = file.size / 1024 / 1024 < 5;
      if (!isLt2M) {
        this.$message.error("上传图片大小不能超过 5MB!");
      }
      this.uploadLoading = true;
      this.type = "image";
      try {
        let filename = file.name.replaceAll(" ", "_");
        let key = new Date().getTime() + filename;
        let obj = {
          filename: key,
          bucketName: "daya",
          postData: {
            filename: key,
            acl: "public-read",
            key,
          },
        };

        // const res = await policy(obj);
        const res = await getUploadSign(obj);
        this.dataObj = {
          policy: res.data.policy,
          signature: res.data.signature,
          key,
          KSSAccessKeyId: res.data.kssAccessKeyId,
          acl: "public-read",
          name: key,
        };

        return isLt2M;
      } catch {
        console.log(res, 12);
        return false;
      }
    },
    async handleAvatarSuccess(info) {
      try {
        const obj = {
          policy: info.data.policy,
          signature: info.data.signature,
          key: info.data.key,
          KSSAccessKeyId: info.data.kssAccessKeyId,
          acl: "public-read",
          name: info.data.key,
          file: info.file,
        };
        console.log(info, this.ossUploadUrl, obj);
        const url = await onOnlyFileUpload(this.ossUploadUrl, obj);

        const formData = new FormData();
        formData.append("avatar", url);
        uploadAvatar({ avatar: url }).then((response) => {
          if (response.code === 200) {
            this.options.img = url;
            store.dispatch("user/setAvatar", url);
            this.msgSuccess("修改成功");
          } else {
            this.msgError(response.msg);
          }
        });
      } catch (e) {
        //
        console.log(e, "e.message");
      }
    },
    // 编辑头像
    editCropper() {
      this.open = true;
    },
    // 覆盖默认的上传行为
    requestUpload(file) {
      console.log(file);
      this.info = file;
    },
    // 向左旋转
    rotateLeft() {
      this.$refs.cropper.rotateLeft();
    },
    // 向右旋转
    rotateRight() {
      this.$refs.cropper.rotateRight();
    },
    // 图片缩放
    changeScale(num) {
      num = num || 1;
      this.$refs.cropper.changeScale(num);
    },
    // 上传预处理
    beforeUpload(file) {
      if (file.type.indexOf("image/") === -1) {
        this.msgError("文件格式错误，请上传图片类型,如：JPG，PNG后缀的文件。");
      } else {
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = () => {
          this.options.img = reader.result;
        };
      }
    },
    // 上传图片
    uploadImg() {
      this.$refs.cropper.getCropBlob(async (data) => {
        console.log(data, "showifo");
        const formData = new FormData();
        formData.append("upload[]", data);
        uploadAvatar(formData).then((response) => {
          if (response.code === 200) {
            this.open = false;
            this.options.img =
              process.env.VUE_APP_BASE_API + "/" + response.data;

            this.msgSuccess("修改成功");
          } else {
            this.msgError(response.msg);
          }
          this.$refs.cropper.clearCrop();
        });
      });
    },
    // 实时预览
    realTime(data) {
      this.previews = data;
    },
  },
};
</script>

<style>
.avatar {
  border-radius: 50%;
  overflow: hidden;
  width: 120px !important;
  height: 120px !important;
}
</style>
